#ifndef AGID_ACL_H
#define AGID_ACL_H 1

/*
*  Header file for acl.c
*/

#include "common.h"

#define ANLD_ACL_FIL  "namelookup.acl"
#define ANLD_ACL_FILE ANLD_CONF_PATH ANLD_ACL_FIL

/*  IPv4-mapped IPv6 ::ffff:  */
unsigned char ip4adrprx[12] = { \
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0xff, 0xff
};

/*  4 to 6 ffff:ffff:ffff:ffff:ffff:ffff:: */
unsigned char ip4mskprx[12] = { \
	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	0xff, 0xff, 0xff, 0xff
};

/*  Localhost  */
struct aclprps localhost[2] = { \
	/*  127.0.0.1 => ::ffff:7f00:0001  */
	{{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0xff, 0xff, 0x7f, 0x00, 0x00, 0x01  },
	/*  /32 => /128  */
	 { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff  }},
	/*  ::1  */
	{{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01  },
	/*  /128  */
	 { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
	   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff  }}
};

/*  main.c  */
extern int aclflg;
extern int debflg;
extern char confdir[256];
extern char genbuf[4096];
extern char glogs[256];
extern char ipstr[48];
extern int numacl;
extern struct aclprps *acltab;

/*
*  Declarations
*/
/*  main.c  */
void wrtsysl(char *str, char *str2, int mode);
int wrtolog(char *s1, char *s2);

#endif	/*  acl.h  */

