#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*
*    Blocklist converter for namelookup.agid.
*
*    Author: R.J. van der Putten, Leiden, Holland, 
*    rob at sput dot nl.
* 
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License version 3 as
*    published by the Free Software Foundation.
* 
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*/


#pragma GCC diagnostic ignored "-Wpragmas"
#pragma GCC diagnostic ignored "-Wstringop-truncation"
#pragma GCC diagnostic ignored "-Wformat-truncation"


/*  Name and number  */
#define OLD_NAME_SIZ 32
#define NEW_NAME_SIZ 72
enum { OLD_NAME_MAX = OLD_NAME_SIZ - 1 };
enum { NEW_NAME_MAX = NEW_NAME_SIZ - 1 };


void hlp(void)
{
    fprintf(stderr, "Converts 31-byte blocklist to 71-byte blocklist.\n");
    fprintf(stderr, "Reads from stdin, writes to stdout.\n");
}


int main(int argc, char **argv)
{
    char oldnam[OLD_NAME_SIZ], newnam[NEW_NAME_SIZ];
    memset(oldnam, 0, OLD_NAME_SIZ);
    memset(newnam, 0, NEW_NAME_SIZ);

    if (argc != 1) {
	hlp();
	exit(1);
    }

    while (fread(oldnam, OLD_NAME_SIZ, 1, stdin)) {
	memset(newnam, 0, NEW_NAME_SIZ);
	strncpy(newnam, oldnam, OLD_NAME_MAX);
	fwrite(newnam, NEW_NAME_SIZ, 1, stdout);
    }

    return(0);
}

