#ifndef AGID_COMMON_H
#define AGID_COMMON_H 1

#include <pthread.h>
#include <wchar.h>

#define ANLD_CONF_PATH "/etc/namelookup-agi/"

#define ANLD_BUF_SIZ 4096
enum { ANLD_BUF_MAX  = ANLD_BUF_SIZ - 1};
enum { ANLD_BUF_MAX2 = ANLD_BUF_SIZ - 2};

#define ANLD_NAME_SIZ 72
#define ANLD_NUM_SIZ  20
enum { ANLD_NAME_MAX = ANLD_NAME_SIZ - 1 };
enum { ANLD_NUM_MAX  = ANLD_NUM_SIZ  - 1 };

/*
*  Timeouts: us
*/
/*  Pre close()  */
#define ANLD_CLS_SOCK_TIM 100000	/*  100 ms  */
/*
*  Pre terminate all treads
*  Should be >= ANLD_CLS_SOCK_TIM
*/
#define ANLD_KIL_THRD_TIM 200000	/*  200 ms  */

/*  Db Lookup modes  */
enum {
	ANLD_NAME, ANLD_WEB, ANLD_AREA, ANLD_REGION
};

/*  ACL  */
struct aclprps {
	unsigned char net[16];
	unsigned char mask[16];
};

/*  Phone number or location  */
struct phnum {
	char num[ANLD_NUM_SIZ];		/*  Phone number  */
	int  len;			/*  Phone number length  */
	char name[ANLD_NAME_SIZ];	/*  Name  */
};

/*  Phone number or location index  */
struct phidx {
	char num[ANLD_NUM_SIZ];	/*  Phone number  */
	int  len;		/*  Phone number length  */
	int  offs;		/*  Name file offset  */
	int  namlen;		/*  Name length  */
};

/*  Phone number index and list  */
struct phndb {
	struct phidx *idx;	/*  Index  */
	char  *lst;		/*  Names or locations  */
	size_t idxsiz;		/*  Index size  */
	size_t lstsiz;		/*  List size  */
	int    ent;		/*  Number of entries  */
	int    pad;
};

/*  Web lookup  */
struct webprc {
	char comnd[256];
	char name[256];
	int chrcnt;
	int lincnt;
	int cmptr;
	int found;
	int namptr;
	int pad;
	FILE *pweb;
};

/*  Thread table  */
struct thrdprps {
	pthread_t thrdid;	/*  Thread Id  */
	int id;			/*  Id  */
	int sfd;		/*  Socket FD  */
	int lktyp;		/*  Lookup Type  */
	volatile int cont;	/*  Continue thread if not zero  */
	struct phnum phone;
	char lnam[ANLD_NAME_SIZ];
	char logstr[256];
	char bufs[2][ANLD_BUF_SIZ];
	wchar_t wnam[ANLD_NAME_SIZ];
	struct webprc weblkp;
};

#endif	/*  common.h  */

