#ifndef AGID_MAIN_H
#define AGID_MAIN_H 1

/*  Header file for main.c  */

#include "common.h"

/*  Default port to listen on  */
#define ANLD_DFLT_PORT 4573

/*  URL and name search properties  */
struct urlprps {
	char preget[256];
	char pstget[256];
	char prepost[256];
	char pstpost[256];
	char prename[256];
	char pstname[256];
	int prenmlen;
	int pstnmlen;
	int atlin;
	int atcol;
};

/*  Default nr of threads  */
#define ANLD_DFLT_THRDS 16
/*  Check threads  */
#define ANLD_CHK_TRD_TIM 5

/*  Lookup log strings  */
char *lookups[4] = {"DbLk", "WbLk", "ArLk", "RgLk"};

/*
*    Files and paths
*/

/*  Config files  */
#define ANLD_CONF_FIL  "agi-namelookup.conf"
#define ANLD_BLCK_FIL  "agi-nameblock.db"
/*  With paths  */
#define ANLD_CONFIG_FILE ANLD_CONF_PATH ANLD_CONF_FIL
#define ANLD_BLOCK_FILE  ANLD_CONF_PATH ANLD_BLCK_FIL

/*  Home dir  */
#define ANLD_HOME_DIR  "/var/local/lib/namelookup/"

/*  Databases  */
#define ANLD_NUMS_PATH "/var/local/lib/phonebook/"
#define ANLD_NUMS_FIL  "numbers.db"
#define ANLD_NUMS_IDX  "numbers.idx"
#define ANLD_NUMS_LST  "numbers.lst"
#define ANLD_AREA_FIL  "areas.db"
#define ANLD_AREA_IDX  "areas.idx"
#define ANLD_AREA_LST  "areas.lst"
#define ANLD_REGS_FIL  "regions.db"
#define ANLD_REGS_IDX  "regions.idx"
#define ANLD_REGS_LST  "regions.lst"
/*  With paths  */
#define ANLD_NUMBERS_FILE  ANLD_NUMS_PATH ANLD_NUMS_FIL
#define ANLD_NUMBERS_INDEX ANLD_NUMS_PATH ANLD_NUMS_IDX
#define ANLD_NUMBERS_LIST  ANLD_NUMS_PATH ANLD_NUMS_LST
#define ANLD_AREAS_FILE    ANLD_NUMS_PATH ANLD_AREA_FIL
#define ANLD_AREAS_INDEX   ANLD_NUMS_PATH ANLD_AREA_IDX
#define ANLD_AREAS_LIST    ANLD_NUMS_PATH ANLD_AREA_LST
#define ANLD_REGIONS_FILE  ANLD_NUMS_PATH ANLD_REGS_FIL
#define ANLD_REGIONS_INDEX ANLD_NUMS_PATH ANLD_REGS_IDX
#define ANLD_REGIONS_LIST  ANLD_NUMS_PATH ANLD_REGS_LST

/*  Pid file  */
#define ANLD_PID_FIL   "namelookup.pid"
#define ANLD_PID_PATH  "/run/namelookup/"
#define ANLD_PID_PATH2 "/run/"
/*  With path  */
#define ANLD_PID_FILE  ANLD_PID_PATH  ANLD_PID_FIL
#define ANLD_PID_FILE2 ANLD_PID_PATH2 ANLD_PID_FIL

/*  Curl  */
#define ANLD_CURL_COMND "curl --no-styled-output -k -m 5 -s"

/*  Website config  */
#define ANLD_WEBC_FIL    "weblookup.conf"
#define ANLD_WEBCNF_FILE ANLD_CONF_PATH ANLD_WEBC_FIL

/*  Log file  */
#define ANLD_LOG_PATH "/var/local/log/namelookup/"
#define ANLD_LOG_FIL  "namelookup.log"
#define ANLD_LOG_FILE ANLD_LOG_PATH ANLD_LOG_FIL

/*
*  Declarations
*/

/*  acl.c  */
int autoacl(void);
int chkacl(struct in6_addr *remaddr);
int readacl(void);

/*  net.c  */
int openlsock(struct sockaddr_in6 *addr, uint16_t port, int backlog);
void * proclsock(void *idnum);

#endif	/*  agid-namelookup.h  */

